; 
 
.486                             ; set processor model
.model flat, stdcall         ; default STDCALL calling convention
option casemap :none    ; always use the case sensitive option 
 

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include  \masm32\include\CObject.inc

includelib \masm32\lib\kernel32.lib


.data
TBLINIT CObject

.code

; 
ptrCreateObject    proc C uses ebx esi edi  vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov ebx, vmtObject
    invoke LocalAlloc,GMEM_FIXED or GMEM_ZEROINIT,[ebx + vmtOffsetInstanceSize]
    or eax, eax
    jz  @@Exit

    cld
    mov edi, eax   
    mov esi, [ebx + vmtOffsetDateTable]
    mov edx, [ebx + vmtOffsetInstanceSize]
    mov ecx, edx
    shr ecx, 2
    rep movsd
    mov ecx, edx 
    and ecx, 03h
    rep movsb
           
    mov ecx, Count
    or ecx, ecx
    jz @@Exit

@@Loop:
    push [ebp + ecx*4 + 12]      
    dec ecx
    jnz @@Loop
    xchg eax, ebx            
    push ebx

    call (VMT_CObject PTR [eax]).InitInstance

    mov eax, ebx
@@Exit:        
    ret
    
ptrCreateObject    endp

; 
ptrGetInstanceSize  proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
    mov eax, [eax + vmtOffsetInstanceSize]
    
    ret
    
ptrGetInstanceSize  endp

; 
ptrGetInitInstanceTable     proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
    mov eax, [eax + vmtOffsetDateTable]
    
    ret
    
ptrGetInitInstanceTable     endp

; 
ptrGetVirtualTable     proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
        
    ret
    
ptrGetVirtualTable     endp

; 
ptrGetVirtualTableSize     proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
    mov eax, [eax + vmtOffsetVMTSize]
    
    ret
    
ptrGetVirtualTableSize     endp

; 
ptrInitInstance     proc lpThis:DWORD

    ret
    
ptrInitInstance     endp       

; 
ptrDestroyObject     proc lpThis:DWORD

    mov eax, lpThis
    or eax, eax
    je @@Exit 
    invoke LocalFree, eax
    
@@Exit:        
    ret
    
ptrDestroyObject     endp

; 
ptrFreeObject   proc lpThis:DWORD

    invokemtd [lpThis].CObject.Destroy
   
    ret
    
ptrFreeObject   endp

end